<?php

/**
 * Platnosci CashBill S.A.
 *
 * @package		CashBill
 * @author		G.M.
 * @link		http://www.cashbill.pl
 */
	
 class ControllerExtensionPaymentCashBill extends Controller {
	private $error = array();
    private $version = '1.4.0';
	public function index() {
		$this->load->language('extension/payment/cashbill');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('cashbill', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'], 'SSL'));
		}

	    $data['heading_title']=$this->language->get('heading_title');

		$data['text_enabled']=$this->language->get('text_enabled');
		$data['text_disabled']=$this->language->get('text_disabled');

		$data['entry_pp_user']=$this->language->get('entry_pp_user');
		$data['entry_pp_id']=$this->language->get('entry_pp_id');
		$data['entry_pp_key']=$this->language->get('entry_pp_key');

		$data['entry_start_order_status']=$this->language->get('entry_start_order_status');
		$data['entry_paid_order_status']=$this->language->get('entry_paid_order_status');
		$data['entry_cancel_order_status']=$this->language->get('entry_cancel_order_status');
		
		$data['entry_pay_text'] = $this->language->get('entry_pay_text');
		
		$data['entry_status']=$this->language->get('entry_status');
		$data['entry_mode']=$this->language->get('entry_mode');
		$data['entry_mode_test_prod']=$this->language->get('entry_mode_test_prod');
		$data['entry_mode_test_ok']=$this->language->get('entry_mode_test_ok');
		$data['entry_sort_order']=$this->language->get('entry_sort_order');
		$data['user_back_url'] = HTTP_CATALOG . 'index.php?route=extension/payment/cashbill/callback';
		$data['server_back_url'] = HTTP_CATALOG . 'index.php?route=extension/payment/cashbill/callback';
		
		$data['button_save']=$this->language->get('button_save');
		$data['button_cancel']=$this->language->get('button_cancel');

		$data['tab_general']=$this->language->get('tab_general');
		
  		if (isset($this->error['warning'])) {
			$data['error_warning']=$this->error['warning'];
		} 
		else 
		{
			$data['error_warning']='';
		}

 		if (isset($this->error['cashbill_pp_user'])) 
 		{
			$data['error_pp_user']=$this->error['cashbill_pp_user'];
		} 
		else 
		{
			$data['error_pp_user']='';
		}
		
		if (isset($this->error['cashbill_pay_title']))
		{
			$data['error_pay_title']=$this->error['cashbill_pay_title'];
		}
		else
		{
			$data['error_pay_title']='';
		}

 		if (isset($this->error['cashbill_pp_id'])) 
 		{
			$data['error_pp_id']=$this->error['cashbill_pp_id'];
		} 
		else 
		{
			$data['error_pp_id']='';
		}

 		if (isset($this->error['cashbill_pp_key'])) 
 		{
			$data['error_pp_key']=$this->error['cashbill_pp_key'];
		} 
		else{
			$data['error_pp_key']='';
		}

		
		$data['version_info'] = $this->checkVersion();

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment/cashbill', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/cashbill', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['warn_currency'] = $this->language->get('text_supported_currency');

		$data['action']=$this->url->link('extension/payment/cashbill', 'token=' . $this->session->data['token'], 'SSL');
		
		$data['cancel']=$this->url->link('extension/extension', 'token=' . $this->session->data['token'], 'SSL');
		
		if(isset($this->request->post['cashbill_pp_user'])){
			$data['cashbill_pp_user']=$this->request->post['cashbill_pp_user'];
		} 
		else{
			$data['cashbill_pp_user']=$this->config->get('cashbill_pp_user');
		}
		
		if(isset($this->request->post['cashbill_pp_id'])) 
		{
			$data['cashbill_pp_id']=$this->request->post['cashbill_pp_id'];
		} 
		else{
			$data['cashbill_pp_id']=$this->config->get('cashbill_pp_id');
		}
		
		if(isset($this->request->post['cashbill_pp_key'])) 
		{
			$data['cashbill_pp_key']=$this->request->post['cashbill_pp_key'];
		} 
		else{
			$data['cashbill_pp_key']=$this->config->get('cashbill_pp_key');
		}
		
		if(isset($this->request->post['cashbill_pay_title']))
		{
			$data['cashbill_pay_title']=$this->request->post['cashbill_pay_title'];
		}
		else{
			$data['cashbill_pay_title']=$this->config->get('cashbill_pay_title');
		}
		
		
		
		if(isset($this->request->post['cashbill_paid_order_status_id'])) 
		{
			$data['cashbill_paid_order_status_id']=
				$this->request->post['cashbill_paid_order_status_id'];
		} 
		else{
			$data['cashbill_paid_order_status_id']=
				$this->config->get('cashbill_paid_order_status_id'); 
		} 
		if(isset($this->request->post['cashbill_start_order_status_id']))
		{
		    $data['cashbill_start_order_status_id']=
		    $this->request->post['cashbill_start_order_status_id'];
		}
		else{
		    $data['cashbill_start_order_status_id']=
		    $this->config->get('cashbill_start_order_status_id');
		}
		
		if(isset($this->request->post['cashbill_cancel_order_status_id']))
		{
		    $data['cashbill_cancel_order_status_id']=
		    $this->request->post['cashbill_cancel_order_status_id'];
		}
		else{
		    $data['cashbill_cancel_order_status_id']=
		    $this->config->get('cashbill_cancel_order_status_id');
		}
		
		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if(isset($this->request->post['cashbill_status'])) 
		{
			$data['cashbill_status']=$this->request->post['cashbill_status'];
		}
		else 
		{
			$data['cashbill_status']=$this->config->get('cashbill_status');
		}
		
		if(isset($this->request->post['cashbill_mode']))
		{
			$data['cashbill_mode']=$this->request->post['cashbill_mode'];
		}
		else 
		{
			$data['cashbill_mode']=$this->config->get('cashbill_mode');
		}
		
		if(isset($this->request->post['cashbill_sort_order'])) 
		{
			$data['cashbill_sort_order']=$this->request->post['cashbill_sort_order'];
		} 
		else 
		{
			$data['cashbill_sort_order']=$this->config->get('cashbill_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/cashbill.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/cashbill')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['cashbill_pp_user']) {
		    $this->error['cashbill_pp_user'] = $this->language->get('error_pp_user');
		}
		
		if (!$this->request->post['cashbill_pp_key']) {
		    $this->error['cashbill_pp_key'] = $this->language->get('error_pp_key');
		}
		
		return !$this->error;
	}
	
     public function checkVersion(){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "http://www.cashbill.pl/ajax/module-version-checker.php?cmd=info&module=OpenCart-2.x");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $response = curl_exec($ch);
        curl_close($ch);
        
        $response = json_decode($response);
        
        if(empty($response))
        {

            return '';
        
        }
        
        if ($response->version == $this->version)         
        { 
            return '';
        }
        
        return '<p style="text-align:center;">Aktualnie posiadasz wersję ' . $this->version . ' jednak jest już dostępna nowsza wersja ' . $response->version . '.</p><p style="text-align:center;"> Możesz ją pobrać korzystając z tego linku <a href="http://www.cashbill.pl/' . $response->link . '">moduł dla ' . $response->name . ' w wersji ' . $response->version . '</a><p>';
    }
	
}
